
import string, Acquisition

from Globals import HTMLFile, MessageDialog, INSTANCE_HOME

from OFS.Folder import Folder

from Products.exUserFolder.exUserFolder import exUserFolder
from Products.exUserFolder.Plugins import PluginRegister

import sys
import string

if sys.version[:5] == '1.5.2' :
	import re
else:
	import re

from Products.zExtraExAuths.ExternalBase.ExternalBase import ExternalBase

def manage_add_AuthMODAdapter(self, REQUEST):

	""" """
	host=REQUEST['host']
	port=REQUEST['port']
	cache_time=REQUEST['cache_time']
	time_out=REQUEST['time_out']
	
	ob = AuthMODAdapter (id='AuthMODAdapter', host=host, port=port, cache_time=cache_time, time_out=time_out)
	ob.postInitialisation(REQUEST)
	
	self._setObject('AuthMODAdapter', ob)
	self.currentAuthSource=ob

manage_edit_AuthMODAdapter_SourceForm=HTMLFile('manage_edit_AuthMODAdapter_SourceForm', globals())
manage_add_AuthMODAdapter_SourceForm=HTMLFile('manage_add_AuthMODAdapter_SourceForm', globals())

class AuthMODAdapter(ExternalBase):
	### These stuff define what this connection waits for. They are all regexs ###
	# [Subgroup that has the bit, leftovers, regex]
	connectstart = [0, 2, re.compile("(.*?)220(.*)", re.DOTALL)]
	sendusername = [0, 2, re.compile("(.*?)ready.(.*)", re.DOTALL)]
	sendpassword = [0, 1, re.compile("(.*)", re.DOTALL)]
	passwordok =   [0, 3, re.compile("(.*?)200(.)Command OK(.*)", re.DOTALL)]
	passwordnotokay = [0, 3, re.compile("(.*?)530(.*?)Failed(.*)", re.DOTALL)]
	error = [0, 2, re.compile("(.*)5[0-9]0(.*)", re.DOTALL)]
	
	### These stuff to send %U is replaced with the username %P with the password
	username = "upgl %s"
	password = " %s\n"
	after = "QUIT\n"
	
	per = 0
	
	manage_editForm=manage_edit_AuthMODAdapter_SourceForm

	def manage_editAuthSourceAfter(self, REQUEST):
		# Context for the users
		self.ucontext = str(REQUEST['user_context'])
		self.username = "upgl %%s%s" % (self.ucontext)

		self._p_changed = 1
	
	def postInitialisation(self, REQUEST):
		# Context for the users
		self.ucontext = str(REQUEST['user_context'])
		self.username = "upgl %%s%s" % (self.ucontext)

		self._p_changed = 1
		
	def finishUp(self, data, thesocket, username):

		# Get the data
		okay = 1
		while okay:
			a = thesocket.recv(1)
			if len(a) == 0:
				okay = 0
			else:
				data = data + a

		lines = string.split(data, '\n')

		# Remove the first and last 2 lines because it's garbage
		lines = lines[1:-3]
		print lines

		rolestring = self.currentPropSource.getUserProperty(username=username, key='_roles', default=None)
		roles = []
		
		# Get all the current roles
		if rolestring != None and rolestring != "":
			for i in string.split(rolestring, ','):
				roles.append(string.strip(i))

		# Go through the lines and get the roles
		for line in lines:

			line = string.strip(line)
			
			try:
				role = string.split(line, '.')[0]
				if role not in roles:
					if rolestring == None or rolestring == "":
						rolestring = role
					else:
						rolestring = rolestring + "," + role
					roles.append(role)
					
			except:
				# Error so lets ignore the line.
				continue

		self.currentPropSource.setUserProperty(username=username, key='_roles',
						       value=rolestring)

AuthMODAdapter_Reg=PluginRegister('AuthMODAdapter', 'AuthMOD (Novell) Authentication Source',
						 AuthMODAdapter, manage_add_AuthMODAdapter_SourceForm,
						 manage_add_AuthMODAdapter,
						 manage_edit_AuthMODAdapter_SourceForm, None)

exUserFolder.authSources['AuthMODAdapter']=AuthMODAdapter_Reg

